Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPDiscreteTwoBody.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPDiscreteTwoBody.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPDiscreteTwoBody.cc	(revision 962)
@@ -28,4 +28,7 @@
 // A prototype of the low energy neutron transport model.
 //
+//080612 Bug fix contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #2,3
+//080709 Bug fix Sampling Legendre expansion by T. Koi   
+//
 #include "G4NeutronHPDiscreteTwoBody.hh"
 #include "G4Gamma.hh"
@@ -92,8 +95,11 @@
      if(theCoeff[it].GetRepresentation()==0)
      {
+//TK Legendre expansion
        G4NeutronHPLegendreStore theStore(1);
        theStore.SetCoeff(0, theCoeff);
        theStore.SetManager(theManager);
-       cosTh = theStore.SampleMax(anEnergy);
+       //cosTh = theStore.SampleMax(anEnergy);
+       //080612TK contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #3
+       cosTh = theStore.SampleDiscreteTwoBody(anEnergy);
      }
      else if(theCoeff[it].GetRepresentation()==12) // means LINLIN
@@ -136,4 +142,5 @@
        if(theCoeff[it].GetRepresentation()==0)
        {
+//TK Legendre expansion
 	 G4NeutronHPLegendreStore theStore(2);
 	 theStore.SetCoeff(0, &(theCoeff[it-1]));
@@ -142,5 +149,7 @@
          aManager.Init(theManager.GetScheme(it), 2);
          theStore.SetManager(aManager);
-	 cosTh = theStore.SampleMax(anEnergy);
+	 //cosTh = theStore.SampleMax(anEnergy);
+//080709 TKDB
+         cosTh = theStore.SampleDiscreteTwoBody(anEnergy);
        }
        else if(theCoeff[it].GetRepresentation()==12) // LINLIN
@@ -198,5 +207,5 @@
 	 cosTh = theStore.Sample();
        }
-       else if(theCoeff[it].GetRepresentation()==14) 
+       else if(theCoeff[it].GetRepresentation()==14) //TK LOG_LIN
        {
 	 G4NeutronHPVector theBuff1;
@@ -266,11 +275,17 @@
 // now get the energy from kinematics and Q-value.
 
-   G4double restEnergy = anEnergy+GetQValue();
+   //G4double restEnergy = anEnergy+GetQValue();
    
 // assumed to be in CMS @@@@@@@@@@@@@@@@@
 
-   G4double residualMass =   GetTarget()->GetMass() + GetNeutron()->GetMass()
-                           - result->GetMass() - GetQValue();
-   G4double kinE = restEnergy/(1+result->GetMass()/residualMass); // non relativistic @@
+   //080612TK contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #2
+   //G4double residualMass =   GetTarget()->GetMass() + GetNeutron()->GetMass()
+   //                        - result->GetMass() - GetQValue();
+   //G4double kinE = restEnergy/(1+result->GetMass()/residualMass); // non relativistic @@
+   G4double A1     =  GetTarget()->GetMass()/GetNeutron()->GetMass(); 
+   G4double A1prim =  result->GetMass()/GetNeutron()->GetMass();
+   G4double E1     =  (A1+1)*(A1+1)/A1/A1*anEnergy; 
+   G4double kinE = (A1+1-A1prim)/(A1+1)/(A1+1)*(A1*E1+(1+A1)*GetQValue());
+
    result->SetKineticEnergy(kinE); // non relativistic @@
    G4double phi = twopi*G4UniformRand();
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPElasticData.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPElasticData.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPElasticData.cc	(revision 962)
@@ -31,4 +31,7 @@
 // 070613 fix memory leaking by T. Koi
 // 071002 enable cross section dump by T. Koi
+// 080428 change checking point of "neglecting doppler broadening" flag 
+//        from GetCrossSection to BuildPhysicsTable by T. Koi
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 #include "G4NeutronHPElasticData.hh"
@@ -49,4 +52,5 @@
 // TKDB
    theCrossSections = 0;
+   onFlightDB = true;
   BuildPhysicsTable(*G4Neutron::Neutron());
 }
@@ -65,4 +69,8 @@
   if(&aP!=G4Neutron::Neutron()) 
      throw G4HadronicException(__FILE__, __LINE__, "Attempt to use NeutronHP data for particles other than neutrons!!!");  
+
+//080428
+   if ( getenv( "G4NEUTRONHP_NEGLECT_DOPPLER" ) ) onFlightDB = false;
+
   size_t numberOfElements = G4Element::GetNumberOfElements();
 // TKDB
@@ -131,5 +139,5 @@
 
 #include "G4Nucleus.hh"
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 #include "G4Neutron.hh"
 #include "G4Electron.hh"
@@ -146,5 +154,7 @@
 
   // T. K. 
-  if ( getenv( "G4NEUTRONHP_NEGLECT_DOPPLER" ) )
+//  if ( getenv( "G4NEUTRONHP_NEGLECT_DOPPLER" ) )
+//080428
+  if ( !onFlightDB )
   {
      G4double factor = 1.0;
@@ -171,5 +181,5 @@
 
 
-  eleMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theZ+eps), static_cast<G4int>(theA+eps))
+  eleMass = ( G4NucleiProperties::GetNuclearMass( static_cast<G4int>(theA+eps) , static_cast<G4int>(theZ+eps) )
 	     ) / G4Neutron::Neutron()->GetPDGMass();
   
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPElasticFS.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPElasticFS.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPElasticFS.cc	(revision 962)
@@ -30,4 +30,5 @@
 // 25-08-06 New Final State type (refFlag==3 , Legendre (Low Energy) + Probability (High Energy) ) 
 //          is added by T. KOI
+// 080904 Add Protection for negative energy results in very low energy ( 1E-6 eV ) scattering by T. Koi
 //
 #include "G4NeutronHPElasticFS.hh"
@@ -304,6 +305,33 @@
       G4double tM = theTarget.GetMass();
       theTarget.SetTotalEnergy(std::sqrt((tP+tM)*(tP+tM)-2.*tP*tM));
+
+/*
+For debug purpose. 
+Same transformation G4ReactionProduct.Lorentz() by 4vectors
+{
+G4LorentzVector n4p = G4LorentzVector ( theNeutron.GetMomentum() , theNeutron.GetKineticEnergy() + theNeutron.GetMass() );    
+G4cout << "before " << ( n4p.e() - n4p.m() ) / eV<< G4endl;
+G4LorentzVector cm4p = G4LorentzVector ( theCMS.GetMomentum() , theCMS.GetKineticEnergy() + theCMS.GetMass() );    
+n4p.boost( cm4p.boostVector() );
+G4cout << cm4p/eV << G4endl;
+G4cout << "after " <<  ( n4p.e() - n4p.m() ) / eV<< G4endl;
+}
+*/
+
       theNeutron.Lorentz(theNeutron, -1.*theCMS);
+//080904 Add Protection for very low energy (1e-6eV) scattering 
+      if ( theNeutron.GetKineticEnergy() < 0 )
+      {
+         theNeutron.SetMomentum( G4ThreeVector(0) ); 
+         theNeutron.SetTotalEnergy ( theNeutron.GetMass() );
+      }
+
       theTarget.Lorentz(theTarget, -1.*theCMS);
+//080904 Add Protection for very low energy (1e-6eV) scattering 
+      if ( theTarget.GetKineticEnergy() < 0 )
+      {
+         theTarget.SetMomentum( G4ThreeVector(0) ); 
+         theTarget.SetTotalEnergy ( theTarget.GetMass() );
+      }
     }
     else
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPFissionData.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPFissionData.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPFissionData.cc	(revision 962)
@@ -30,4 +30,6 @@
 // 070618 fix memory leaking by T. Koi
 // 071002 enable cross section dump by T. Koi
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
+// 081124 Protect invalid read which caused run time errors by T. Koi
 
 #include "G4NeutronHPFissionData.hh"
@@ -110,4 +112,11 @@
       G4cout << (*theElementTable)[i]->GetName() << G4endl;
 
+      if ( (*((*theCrossSections)(i))).GetVectorLength() == 0 ) 
+      {
+         G4cout << "The cross-section data of the fission of this element is not available." << G4endl; 
+         G4cout << G4endl; 
+         continue;
+      }
+
       G4int ie = 0;
 
@@ -130,5 +139,5 @@
 }
 
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 
 G4double G4NeutronHPFissionData::
@@ -152,5 +161,5 @@
   G4double theZ = anE->GetZ();
   G4double eleMass; 
-  eleMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theZ+eps), static_cast<G4int>(theA+eps))
+  eleMass = ( G4NucleiProperties::GetNuclearMass( static_cast<G4int>(theA+eps) , static_cast<G4int>(theZ+eps) )
 	     ) / G4Neutron::Neutron()->GetPDGMass();
   
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelastic.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelastic.cc	(revision 962)
@@ -33,8 +33,9 @@
 // and all its terms.
 //
-// $Id: G4NeutronHPInelastic.cc,v 1.23 2007/06/22 09:23:48 gcosmo Exp $
-// GEANT4 tag $Name:  $
+// $Id: G4NeutronHPInelastic.cc,v 1.24 2008/12/03 22:28:48 tkoi Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
-// 070523 bug fix for G4FPE_DEBUG on by A. Howard ( and T. Koi)
+// 070523 bug fix for G4FPE_DEBUG on by A. Howard (and T. Koi)
+// 081203 limit maximum trial for creating final states add protection for 1H isotope case by T. Koi
 //
 #include "G4NeutronHPInelastic.hh"
@@ -58,4 +59,5 @@
     { 
       theInelastic[i].Init((*(G4Element::GetElementTable()))[i], dirName);
+      G4int itry = 0;
       do
       {
@@ -97,6 +99,19 @@
 	theInelastic[i].Register(&theDAFS, "F36");
 	theInelastic[i].RestartRegistration();
+        itry++;
       }
-      while(!theInelastic[i].HasDataInAnyFinalState());
+      //while(!theInelastic[i].HasDataInAnyFinalState());
+      while( !theInelastic[i].HasDataInAnyFinalState() && itry < 6 );
+                                                              // 6 is corresponding to the value(5) of G4NeutronHPChannel. TK  
+      if ( itry == 6 ) 
+      {
+         // No Final State at all.
+         G4bool exceptional = false;
+         if ( (*(G4Element::GetElementTable()))[i]->GetNumberOfIsotopes() == 1 )
+         {
+            if ( (*(G4Element::GetElementTable()))[i]->GetIsotope( 0 )->GetZ() == 1 && (*(G4Element::GetElementTable()))[i]->GetIsotope( 0 )->GetN() == 1 ) exceptional = true;  //1H
+         } 
+         if ( !exceptional ) throw G4HadronicException(__FILE__, __LINE__, "Channel: Do not know what to do with this element");
+      }
     }
   }
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticBaseFS.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticBaseFS.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticBaseFS.cc	(revision 962)
@@ -28,11 +28,17 @@
 // A prototype of the low energy neutron transport model.
 //
+// 080801 Give a warning message for irregular mass value in data file by T. Koi
+//        Introduce theNDLDataA,Z which has A and Z of NDL data by T. Koi
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
+//
 #include "G4NeutronHPInelasticBaseFS.hh"
 #include "G4Nucleus.hh"
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 #include "G4He3.hh"
 #include "G4Alpha.hh"
 #include "G4Electron.hh"
 #include "G4NeutronHPDataUsed.hh"
+
+#include "G4ParticleTable.hh"
 
 void G4NeutronHPInelasticBaseFS::InitGammas(G4double AR, G4double ZR)
@@ -55,6 +61,6 @@
    G4double eps = 0.001;
    theNuclearMassDifference = 
-       G4NucleiPropertiesTable::GetBindingEnergy(static_cast<G4int>(ZR+eps),static_cast<G4int>(AR+eps)) -
-       G4NucleiPropertiesTable::GetBindingEnergy(static_cast<G4int>(theBaseZ+eps), static_cast<G4int>(theBaseA+eps));
+       G4NucleiProperties::GetBindingEnergy(static_cast<G4int>(AR+eps),static_cast<G4int>(ZR+eps)) -
+       G4NucleiProperties::GetBindingEnergy(static_cast<G4int>(theBaseA+eps), static_cast<G4int>(theBaseZ+eps));
    theGammas.Init(theGammaData);
    //   delete aName;
@@ -74,4 +80,6 @@
   theBaseA = aFile.GetA();
   theBaseZ = aFile.GetZ();
+   theNDLDataA = (int)aFile.GetA();
+   theNDLDataZ = aFile.GetZ();
   if(!dbool || ( Z<2.5 && ( std::abs(theBaseZ - Z)>0.0001 || std::abs(theBaseA - A)>0.0001)))
   {
@@ -170,5 +178,5 @@
   G4double targetMass;
   G4double eps = 0.0001;
-  targetMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theBaseZ+eps), static_cast<G4int>(theBaseA+eps))) /
+  targetMass = ( G4NucleiProperties::GetNuclearMass(static_cast<G4int>(theBaseA+eps), static_cast<G4int>(theBaseZ+eps))) /
                G4Neutron::Neutron()->GetPDGMass();
   if(theEnergyAngData!=0)
@@ -176,4 +184,6 @@
   if(theAngularDistribution!=0)
      { targetMass = theAngularDistribution->GetTargetMass(); }
+//080731a
+if ( targetMass == 0 ) G4cout << "080731a It looks like something wrong value in G4NDL, please update the latest version. If you use the latest, then please report this problem to Geant4 Hyper news." << G4endl;
   G4Nucleus aNucleus;
   G4ReactionProduct theTarget; 
@@ -255,5 +265,5 @@
     }
     G4ReactionProduct * aHadron;
-    G4double localMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theBaseZ+eps), static_cast<G4int>(theBaseA+eps)));
+    G4double localMass = ( G4NucleiProperties::GetNuclearMass(static_cast<G4int>(theBaseA+eps), static_cast<G4int>(theBaseZ+eps)));
     G4ThreeVector bufferedDirection(0,0,0);
     for(i0=0; i0<nDef; i0++)
@@ -291,5 +301,5 @@
 	    G4int z1 = static_cast<G4int>(theBaseZ+eps-theDefs[0]->GetPDGCharge()-theDefs[1]->GetPDGCharge());
 	    G4int a1 = static_cast<G4int>(theBaseA+eps)-theDefs[0]->GetBaryonNumber()-theDefs[1]->GetBaryonNumber();
-	    G4double concreteMass = G4NucleiPropertiesTable::GetNuclearMass(z1, a1);
+	    G4double concreteMass = G4NucleiProperties::GetNuclearMass(a1, z1);
 	    G4double availableEnergy = eKinetic+mn+localMass-m1-m2-concreteMass;
 	    // available kinetic energy in CMS (non relativistic)
@@ -357,8 +367,8 @@
     G4double eBindN = 0;
     G4double eBindP = 0;
-    G4double eBindD = G4NucleiPropertiesTable::GetBindingEnergy(1,2);
-    G4double eBindT = G4NucleiPropertiesTable::GetBindingEnergy(1,3);
-    G4double eBindHe3 = G4NucleiPropertiesTable::GetBindingEnergy(2,3);
-    G4double eBindA = G4NucleiPropertiesTable::GetBindingEnergy(2,4);
+    G4double eBindD = G4NucleiProperties::GetBindingEnergy(2,1);
+    G4double eBindT = G4NucleiProperties::GetBindingEnergy(3,1);
+    G4double eBindHe3 = G4NucleiProperties::GetBindingEnergy(3,2);
+    G4double eBindA = G4NucleiProperties::GetBindingEnergy(4,2);
     for(i=0; i<tmpHadrons->size(); i++)
     {
@@ -455,4 +465,11 @@
   delete tmpHadrons;
 
+//080721 
+   G4ParticleDefinition* targ_pd = G4ParticleTable::GetParticleTable()->GetIon ( (G4int)theBaseZ , (G4int)theBaseA , 0.0 );
+   G4LorentzVector targ_4p_lab ( theTarget.GetMomentum() , std::sqrt( targ_pd->GetPDGMass()*targ_pd->GetPDGMass() + theTarget.GetMomentum().mag2() ) );
+   G4LorentzVector proj_4p_lab = theTrack.Get4Momentum();
+   G4LorentzVector init_4p_lab = proj_4p_lab + targ_4p_lab;
+   adjust_final_state ( init_4p_lab ); 
+
 // clean up the primary neutron
   theResult.SetStatusChange(stopAndKill);
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticCompFS.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticCompFS.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticCompFS.cc	(revision 962)
@@ -30,8 +30,14 @@
 // 070523 bug fix for G4FPE_DEBUG on by A. Howard ( and T. Koi)
 // 070606 bug fix and migrate to enable to Partial cases by T. Koi 
+// 080603 bug fix for Hadron Hyper News #932 by T. Koi 
+// 080612 bug fix contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #4,6
+// 080717 bug fix of calculation of residual momentum by T. Koi
+// 080801 protect negative avalable energy by T. Koi
+//        introduce theNDLDataA,Z which has A and Z of NDL data by T. Koi
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 #include "G4NeutronHPInelasticCompFS.hh"
 #include "G4Nucleus.hh"
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 #include "G4He3.hh"
 #include "G4Alpha.hh"
@@ -74,4 +80,6 @@
   theBaseA = aFile.GetA();
   theBaseZ = aFile.GetZ();
+   theNDLDataA = (int)aFile.GetA();
+   theNDLDataZ = aFile.GetZ();
   if(!dbool || ( Z<2.5 && ( std::abs(theBaseZ - Z)>0.0001 || std::abs(theBaseA - A)>0.0001)))
   {
@@ -185,8 +193,9 @@
 }
 
+
+                                                                                                       //n,p,d,t,he3,a
 void G4NeutronHPInelasticCompFS::CompositeApply(const G4HadProjectile & theTrack, G4ParticleDefinition * aDefinition)
 {
 
-    //G4cout << "G4NeutronHPInelasticCompFS::CompositeApply " << G4endl; 
 // prepare neutron
     theResult.Clear();
@@ -201,7 +210,8 @@
     for(i=0; i<50; i++)
     { if(theXsection[i] != 0) { break; } } 
+
     G4double targetMass=0;
     G4double eps = 0.0001;
-    targetMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theBaseZ+eps), static_cast<G4int>(theBaseA+eps))) /
+    targetMass = ( G4NucleiProperties::GetNuclearMass(static_cast<G4int>(theBaseA+eps), static_cast<G4int>(theBaseZ+eps))) /
                    G4Neutron::Neutron()->GetPDGMass();
 //    if(theEnergyAngData[i]!=0)
@@ -220,5 +230,5 @@
     G4double residualZ = theBaseZ - aDefinition->GetPDGCharge();
     G4double residualA = theBaseA - aDefinition->GetBaryonNumber()+1;
-    residualMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(residualZ+eps), static_cast<G4int>(residualA+eps)) ) /
+    residualMass = ( G4NucleiProperties::GetNuclearMass(static_cast<G4int>(residualA+eps), static_cast<G4int>(residualZ+eps)) ) /
                      G4Neutron::Neutron()->GetPDGMass();
 
@@ -230,5 +240,5 @@
   
 // select exit channel for composite FS class.
-    G4int it = SelectExitChannel(eKinetic);
+    G4int it = SelectExitChannel( eKinetic );
    
 // set target and neutron in the relevant exit channel
@@ -241,20 +251,29 @@
     G4double availableEnergy = theNeutron.GetKineticEnergy() + theNeutron.GetMass() - aHadron.GetMass() +
                              (targetMass - residualMass)*G4Neutron::Neutron()->GetPDGMass();
+//080730c
+    if ( availableEnergy < 0 )
+    {
+       //G4cout << "080730c Adjust availavleEnergy " << G4endl; 
+       availableEnergy = 0; 
+    }
     G4int nothingWasKnownOnHadron = 0;
     G4int dummy;
     G4double eGamm = 0;
     G4int iLevel=it-1;
-//  TK debug 070530  (without photon has it = 0)
-    //if(50==it) 
-    if( 0 == it ) 
-    {
+
+//  TK without photon has it = 0
+    if( 50 == it ) 
+    {
+
+//    TK Excitation level is not determined
       iLevel=-1;
       aHadron.SetKineticEnergy(availableEnergy*residualMass*G4Neutron::Neutron()->GetPDGMass()/
                                (aHadron.GetMass()+residualMass*G4Neutron::Neutron()->GetPDGMass()));
 
-      //aHadron.SetMomentum(theNeutron.GetMomentum()*(1./theNeutron.GetTotalMomentum())*
-      //                  std::sqrt(aHadron.GetTotalEnergy()*aHadron.GetTotalEnergy()-
-      //                            aHadron.GetMass()*aHadron.GetMass()));
-
+      aHadron.SetMomentum(theNeutron.GetMomentum()*(1./theNeutron.GetTotalMomentum())*
+                        std::sqrt(aHadron.GetTotalEnergy()*aHadron.GetTotalEnergy()-
+                                  aHadron.GetMass()*aHadron.GetMass()));
+
+/*
       G4double p2 = ( aHadron.GetTotalEnergy()*aHadron.GetTotalEnergy()-aHadron.GetMass()*aHadron.GetMass() );
       G4double p = 0.0;
@@ -264,4 +283,5 @@
       } 
       aHadron.SetMomentum(theNeutron.GetMomentum()*(1./theNeutron.GetTotalMomentum())*p );
+*/
 
     }
@@ -270,7 +290,9 @@
       while( iLevel!=-1 && theGammas.GetLevel(iLevel)==0 ) { iLevel--; }
     }
-    if(theAngularDistribution[it]!= 0)
-    {
-      if(theEnergyDistribution[it]!=0)
+
+
+    if ( theAngularDistribution[it] != 0 ) // MF4
+    {
+      if(theEnergyDistribution[it]!=0) // MF5
       {
         aHadron.SetKineticEnergy(theEnergyDistribution[it]->Sample(eKinetic, dummy));
@@ -304,5 +326,6 @@
       }
       theAngularDistribution[it]->SampleAndUpdate(aHadron);
-      if(theFinalStatePhotons[it] == 0)
+
+      if( theFinalStatePhotons[it] == 0 )
       {
 // TK comment Most n,n* eneter to this  
@@ -324,5 +347,5 @@
       }
     }
-    else if(theEnergyAngData[it] != 0)  
+    else if(theEnergyAngData[it] != 0) // MF6  
     {
       theParticles = theEnergyAngData[it]->Sample(eKinetic);
@@ -333,14 +356,15 @@
       nothingWasKnownOnHadron = 1;
     }
+
     //G4cout << "theFinalStatePhotons it " << it << G4endl;
     //G4cout << "theFinalStatePhotons[it] " << theFinalStatePhotons[it] << G4endl;
-//  TK 070530
-    if ( it != 0 ) it = 50;  // it 50 has final state data for photon MF13 cross and MF14 ang
     //G4cout << "theFinalStatePhotons it " << it << G4endl;
     //G4cout << "theFinalStatePhotons[it] " << theFinalStatePhotons[it] << G4endl;
     //G4cout << "thePhotons " << thePhotons << G4endl;
-    if(theFinalStatePhotons[it]!=0) 
-    {
-      // the photon distributions are in the Nucleus rest frame.
+
+    if ( theFinalStatePhotons[it] != 0 ) 
+    {
+       // the photon distributions are in the Nucleus rest frame.
+       // TK residual rest frame
       G4ReactionProduct boosted;
       boosted.Lorentz(theNeutron, theTarget);
@@ -493,5 +517,10 @@
 	                          ->GetIon(static_cast<G4int>(residualZ), static_cast<G4int>(residualA), 0));  
         theResidual.SetKineticEnergy(aHadron.GetKineticEnergy()*aHadron.GetMass()/theResidual.GetMass());
-        theResidual.SetMomentum(-1.*aHadron.GetMomentum());
+
+        //080612TK contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #6
+        //theResidual.SetMomentum(-1.*aHadron.GetMomentum());
+	G4ThreeVector incidentNeutronMomentum = theNeutron.GetMomentum();
+        theResidual.SetMomentum(incidentNeutronMomentum - aHadron.GetMomentum());
+
 	theResidual.Lorentz(theResidual, -1.*theTarget);
 	G4ThreeVector totalPhotonMomentum(0,0,0);
@@ -529,5 +558,12 @@
 //        cout << "Kinetic energy of the residual = "<<resiualKineticEnergy<<endl;
 	theResidual.SetKineticEnergy(resiualKineticEnergy);
-        theResidual.SetMomentum(-1.*totalMomentum);
+
+        //080612TK contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #4
+        //theResidual.SetMomentum(-1.*totalMomentum);
+	//G4ThreeVector incidentNeutronMomentum = theNeutron.GetMomentum();
+        //theResidual.SetMomentum(incidentNeutronMomentum - aHadron.GetMomentum());
+//080717 TK Comment still do NOT include photon's mometum which produce by thePhotons
+        theResidual.SetMomentum( theNeutron.GetMomentum() + theTarget.GetMomentum() - totalMomentum );
+
         theSec = new G4DynamicParticle;   
         theSec->SetDefinition(theResidual.GetDefinition());
@@ -549,4 +585,12 @@
       delete thePhotons;
     }
+
+//080721 
+   G4ParticleDefinition* targ_pd = G4ParticleTable::GetParticleTable()->GetIon ( (G4int)theBaseZ , (G4int)theBaseA , 0.0 );
+   G4LorentzVector targ_4p_lab ( theTarget.GetMomentum() , std::sqrt( targ_pd->GetPDGMass()*targ_pd->GetPDGMass() + theTarget.GetMomentum().mag2() ) );
+   G4LorentzVector proj_4p_lab = theTrack.Get4Momentum();
+   G4LorentzVector init_4p_lab = proj_4p_lab + targ_4p_lab;
+   adjust_final_state ( init_4p_lab ); 
+
 // clean up the primary neutron
     theResult.SetStatusChange(stopAndKill);
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticData.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticData.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticData.cc	(revision 962)
@@ -31,4 +31,7 @@
 // 070613 fix memory leaking by T. Koi
 // 071002 enable cross section dump by T. Koi
+// 080428 change checking point of "neglecting doppler broadening" flag 
+//        from GetCrossSection to BuildPhysicsTable by T. Koi
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 #include "G4NeutronHPInelasticData.hh"
@@ -48,4 +51,5 @@
 {
 // TKDB
+   onFlightDB = true;
    theCrossSections = 0;
   BuildPhysicsTable(*G4Neutron::Neutron());
@@ -64,4 +68,8 @@
   if(&aP!=G4Neutron::Neutron()) 
      throw G4HadronicException(__FILE__, __LINE__, "Attempt to use NeutronHP data for particles other than neutrons!!!");  
+
+//080428
+   if ( getenv( "G4NEUTRONHP_NEGLECT_DOPPLER" ) ) onFlightDB = false;
+
   size_t numberOfElements = G4Element::GetNumberOfElements();
 //  theCrossSections = new G4PhysicsTable( numberOfElements );
@@ -130,5 +138,5 @@
 }
 
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 
 G4double G4NeutronHPInelasticData::
@@ -143,5 +151,7 @@
 
   // T. K. 
-  if ( getenv( "G4NEUTRONHP_NEGLECT_DOPPLER" ) )
+//if ( getenv( "G4NEUTRONHP_NEGLECT_DOPPLER" ) )
+//080428
+  if ( !onFlightDB )
   {
      G4double factor = 1.0;
@@ -166,5 +176,5 @@
   G4double theZ = anE->GetZ();
   G4double eleMass; 
-  eleMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theZ+eps), static_cast<G4int>(theA+eps))
+  eleMass = ( G4NucleiProperties::GetNuclearMass(static_cast<G4int>(theA+eps), static_cast<G4int>(theZ+eps))
 	     ) / G4Neutron::Neutron()->GetPDGMass();
   
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPIsoData.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPIsoData.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPIsoData.cc	(revision 962)
@@ -28,4 +28,6 @@
 // A prototype of the low energy neutron transport model.
 //
+//080901 Avoiding troubles which caused by G4PhysicsVecotor of length 0 by T. Koi
+//
 #include "G4NeutronHPIsoData.hh"
 #include "G4NeutronHPDataUsed.hh"
@@ -45,6 +47,8 @@
     {
       if(getenv("NeutronHPNamesLogging")) G4cout << "Skipped = "<< filename <<" "<<A<<" "<<Z<<G4endl;
-      theChannel.close();
-      return false;
+      //080901 TKDB No more necessary below protection, cross sections set to 0 in G4NeutronHPNames
+      //And below two lines causes trouble with G4PhysicsVector
+      //theChannel.close();
+      //return false;
     }
     if(!theChannel) {theChannel.close(); return false;}
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPKallbachMannSyst.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPKallbachMannSyst.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPKallbachMannSyst.cc	(revision 962)
@@ -27,4 +27,6 @@
 // J.P. Wellisch, Nov-1996
 // A prototype of the low energy neutron transport model.
+//
+// 080801 Protect div0 error, when theCompundFraction is 1 by T. Koi
 //
 #include "G4NeutronHPKallbachMannSyst.hh" 
@@ -69,4 +71,9 @@
 {
   G4double result;
+  if ( theCompoundFraction == 1 ) 
+  { 
+     //G4cout << "080730b Adjust theCompoundFraction " << G4endl;
+     theCompoundFraction *= (1-1.0e-15);   
+  } 
   result = 0.5 * (1./A(anEnergy)) * std::log((1-theCompoundFraction)/(1+theCompoundFraction));
   return result;
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPLabAngularEnergy.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPLabAngularEnergy.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPLabAngularEnergy.cc	(revision 962)
@@ -28,4 +28,6 @@
 // A prototype of the low energy neutron transport model.
 //
+// 080808 Bug fix in serching mu bin and index for theBuff2b by T. Koi
+//
 #include "G4NeutronHPLabAngularEnergy.hh"
 #include "G4Gamma.hh"
@@ -111,8 +113,11 @@
    {
      it = i;
-     if(anEnergy<theEnergies[i]) break;
-   }
-   if(it==0 || it == nEnergies-1) // it marks the energy bin
-   {
+     if ( anEnergy < theEnergies[i] ) break;
+   }
+   //080808
+   //if ( it == 0 || it == nEnergies-1 ) // it marks the energy bin
+   if ( it == 0 ) // it marks the energy bin
+   {
+if(it==0) G4cout << "080808 Something unexpected is happen in G4NeutronHPLabAngularEnergy " << G4endl;
      // integrate the prob for each costh, and select theta.
      G4double * running = new G4double [nCosTh[it]];
@@ -130,14 +135,19 @@
        if(random<running[i]) break;
      }
-     if(ith==0 || ith==nCosTh[it]-1)
-     {
-       cosTh = theData[it][ith].GetLabel();
-       secEnergy = theData[it][ith].Sample();
-       currentMeanEnergy = theData[it][ith].GetMeanX();
+     //080807
+     //if ( ith == 0 || ith == nCosTh[it]-1 ) //ith marks the angluar bin
+     if ( ith == 0 ) //ith marks the angluar bin
+     {
+        cosTh = theData[it][ith].GetLabel();
+        secEnergy = theData[it][ith].Sample();
+        currentMeanEnergy = theData[it][ith].GetMeanX();
      }
      else
      {
-       G4double x1 = theData[it][ith-1].GetIntegral();
-       G4double x2 = theData[it][ith].GetIntegral();
+       //080808
+       //G4double x1 = theData[it][ith-1].GetIntegral();
+       //G4double x2 = theData[it][ith].GetIntegral();
+       G4double x1 = running [ ith-1 ];
+       G4double x2 = running [ ith ];
        G4double x = random;
        G4double y1 = theData[it][ith-1].GetLabel();
@@ -157,4 +167,5 @@
          y1 = theData[it][ith-1].GetY(i);
          y2 = theData[it][ith].GetY(mu);
+
          y = theInt.Interpolate(theSecondManager[it].GetScheme(ith), 
                                 cosTh, x1,x2,y1,y2);
@@ -298,9 +309,14 @@
      G4NeutronHPVector theBuff2b;
      theBuff2b.SetInterpolationManager(theData[it][i2].GetInterpolationManager());
-     for(i=0;i<theData[it][i1].GetVectorLength(); i++)
-     {
-       E = theData[it][i1].GetX(i);
-       y1 = theData[it][i1-1].GetY(E);
-       y2 = theData[it][i1].GetY(i);
+     //080808  i1 -> i2
+     //for(i=0;i<theData[it][i1].GetVectorLength(); i++)
+     for(i=0;i<theData[it][i2].GetVectorLength(); i++)
+     {
+       //E = theData[it][i1].GetX(i);
+       //y1 = theData[it][i1-1].GetY(E);
+       //y2 = theData[it][i1].GetY(i);
+       E = theData[it][i2].GetX(i);
+       y1 = theData[it][i2-1].GetY(E);
+       y2 = theData[it][i2].GetY(i);
        y = theInt.Lin(x, x1,x2,y1,y2);
        theBuff2b.SetData(i, E, y); // wrong E, right theta.
@@ -339,5 +355,5 @@
      currentMeanEnergy = theOne.GetMeanX();
    }
-   
+
 // now do random direction in phi, and fill the result.
 
